Attribute VB_Name = "ogl"
Private hRC As Long   'GL window handle
Private gHDC As Long  'Win window handle

Global Texture(10) As Long

Function TextureLoad(number As Integer, Filename As String, Optional mipped As Integer)

If Dir(Filename) = "" Then MsgBox "Missing Texture: " & Filename, , "Texture Load Error": Exit Function

Dim sFile As String
Dim bmFile As BITMAPFILEHEADER
Dim bmInfo As BITMAPINFOHEADER
Dim bmRGB() As RGBQUAD
Dim iFile As Integer
Dim lImageSize As Long
Dim iPixelSize As Integer
Dim baImageData() As Byte

  sFile = App.Path & "\" & Filename
  
  iFile = FreeFile
  
  Open sFile For Binary As iFile
  
  Get #iFile, , bmFile
  Get #iFile, , bmInfo
  
  If (bmInfo.biBitCount < 24) Then
    ReDim bmRGB(bmInfo.biClrUsed)
    Get #iFile, , bmRGB
  End If
  
  iPixelSize = bmInfo.biBitCount / 8
  lImageSize = bmInfo.biWidth * bmInfo.biHeight * iPixelSize
  
  ReDim baImageData(lImageSize)
  Get #iFile, , baImageData
  Close #iFile
    
  glGenTextures 1, Texture(number)
  glBindTexture glTexture2D, Texture(number)

If mipped = 1 Then GoTo mipmap
  
  'nomipmap
  glTexParameteri glTexture2D, tpnTextureMagFilter, GL_LINEAR
  glTexParameteri glTexture2D, tpnTextureMinFilter, GL_LINEAR
  glTexImage2D glTexture2D, 0, 3, bmInfo.biWidth, bmInfo.biHeight, 0, tiBGRExt, GL_UNSIGNED_BYTE, baImageData(0)
  
  Exit Function
  
mipmap:
  
  glTexParameteri glTexture2D, tpnTextureMagFilter, GL_LINEAR
  glTexParameteri glTexture2D, tpnTextureMinFilter, GL_LINEAR_MIPMAP_NEAREST
  glTexImage2D glTexture2D, 0, 3, bmInfo.biWidth, bmInfo.biHeight, 0, tiBGRExt, GL_UNSIGNED_BYTE, baImageData(0)
  gluBuild2DMipmaps glTexture2D, 3, bmInfo.biWidth, bmInfo.biHeight, tiBGRExt, GL_UNSIGNED_BYTE, VarPtr(baImageData(0))

End Function


Sub init(pbox As PictureBox)
'Opengl ablak Inicializls
Dim pfd As PIXELFORMATDESCRIPTOR
Dim pixformat As Long

gHDC = pbox.hDC
    
    ZeroMemory pfd, Len(pfd)
    pfd.nSize = Len(pfd)
    pfd.nVersion = 1
    
    pfd.dwFlags = PFD_DRAW_TO_WINDOW Or PFD_SUPPORT_OPENGL Or PFD_DOUBLEBUFFER
    pfd.iPixelType = PFD_TYPE_RGBA
    pfd.cColorBits = 24
    pfd.cDepthBits = 16
    pfd.iLayerType = PFD_MAIN_PLANE

    pixformat = ChoosePixelFormat(gHDC, pfd)
    If pixformat = 0 Then MsgBox "OpenGL window not created!": End
    
    SetPixelFormat gHDC, pixformat, pfd
    hRC = wglCreateContext(gHDC)

    wglMakeCurrent gHDC, hRC

'vetts belltsa
Dim aspectratio As Double
    
    glMatrixMode mmProjection ' projekcis mtrix kivlasts
    aspectratio = pbox.ScaleWidth / pbox.ScaleHeight
    Fovy = 65 ' ltszg
    gluPerspective Fovy, aspectratio, 1, 20  ' vgsk bellts
    glMatrixMode mmModelView
    glLoadIdentity 'egysgmtrix betlts


'textura video memriba tlts
ogl.TextureLoad 0, "logo.bmp", 0
End Sub
